528. Random Pick with Weight
1. Question
You are given an array of positive integers w
where w[i]
describes the weight of ith index (0-indexed).
We need to call the function pickIndex()
which randomly returns an integer in the range [0, w.length - 1]
. pickIndex()
should return the integer proportional to its weight in the w array. For example, for w = [1, 3]
, the probability of picking the index 0
is 1 / (1 + 3) = 0.25
(i.e 25%) while the probability of picking the index 1
is 3 / (1 + 3) = 0.75
(i.e 75%).
More formally, the probability of picking index i
is w[i] / sum(w)
.
2. Examples
Example 1:
Input
["Solution","pickIndex"]
[[[1]],[]]
Output
[null,0]
Explanation
Solution solution = new Solution([1]);
solution.pickIndex(); // return 0. Since there is only one single element on the array the only option is to return the first element.
Example 2:
Input
["Solution","pickIndex","pickIndex","pickIndex","pickIndex","pickIndex"]
[[[1,3]],[],[],[],[],[]]
Output
[null,1,1,1,1,0]
Explanation
Solution solution = new Solution([1, 3]);
solution.pickIndex(); // return 1. It's returning the second element (index = 1) that has probability of 3/4.
solution.pickIndex(); // return 1
solution.pickIndex(); // return 1
solution.pickIndex(); // return 1
solution.pickIndex(); // return 0. It's returning the first element (index = 0) that has probability of 1/4.
Since this is a randomization problem, multiple answers are allowed so the following outputs can be considered correct :
[null,1,1,1,1,0]
[null,1,1,1,1,1]
[null,1,1,1,0,0]
[null,1,1,1,0,1]
[null,1,0,1,0,0]
......
and so on.
3. Constraints
1 <= w.length <= 10000
1 <= w[i] <= 10^5
`pickIndex
will be called at most10000
times.
4. References
来源:力扣(LeetCode) 链接:https://leetcode-cn.com/problems/random-pick-with-weight 著作权归领扣网络所有。商业转载请联系官方授权,非商业转载请注明出处。
5. Solutions
参考 前缀和 加 二分查找
class Solution {
int[] arr;
int sum;
public Solution(int[] w) {
arr = new int[w.length];
arr[0] = w[0];
for (int i = 1; i < w.length; i++) {
arr[i] = arr[i - 1] + w[i];
}
sum = Arrays.stream(arr).sum();
}
public int pickIndex() {
return binarySearch((int) (Math.random() * arr[arr.length - 1] + 1));
}
public int binarySearch(int num) {
int left = 0;
int right = arr.length - 1;
while (left < right) {
int mid = (right - left) / 2 + left;
if (arr[mid] < num) {
left = mid + 1;
} else {
right = mid;
}
}
return left;
}
}
/**
* Your Solution object will be instantiated and called as such:
* Solution obj = new Solution(w);
* int param_1 = obj.pickIndex();
*/